Package org.eclipse.m2m.atl.engine.vm.nativelib

## Class ASMModel

- java.lang.Object
- - org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
  - - org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
    - - org.eclipse.m2m.atl.engine.vm.nativelib.ASMModel

Direct Known Subclasses:
  `ASMEMFModel`, `ASMHashModel`

    public abstract class ASMModel
    extends ASMOclAny

An ASMModel represents a model. This is an abstraction layer for concrete model handlers such as EMF or MDR. At the present time, there is no separate class for metamodels. Therefore some of the methods of ASMModel only apply to metamodels. TODO (for this class and ASMModelElement): separate metamodel-specific in ASMMetamodel and rename some methods.

### Field Summary

Fields
`static ASMOclType` `myType`

### Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`nativeImpl`

### Constructor Summary

Constructors
`ASMModel​(java.lang.String name, ASMModel metamodel, boolean isTarget, ModelLoader ml)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract ASMModelElement` `findModelElement​(java.lang.String name)` Finds a Classifier in a Metamodel.
`java.util.Set` `getElementsByType​(java.lang.String typeName)`
`abstract java.util.Set` `getElementsByType​(ASMModelElement type)`
`ASMModel` `getMetamodel()`
`ModelLoader` `getModelLoader()`
`java.lang.String` `getName()`
`boolean` `isCheckSameModel()` Returns whether this model allows references to other models (inter-model references).
`boolean` `isTarget()`
`ASMModelElement` `newModelElement​(java.lang.String typeName)`
`abstract ASMModelElement` `newModelElement​(ASMModelElement type)`
`ASMModelElement` `newModelElement​(StackFrame frame, java.lang.String typeName)`
`void` `setCheckSameModel​(boolean checkSameModel)` Sets whether this model allows references to other models (inter-model references).
`void` `setIsTarget​(boolean isTarget)`
`java.lang.String` `toString()`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny

`asBag, asSequence, asSet, check, debug, findOperation, findOperation, get, getHelper, getNamedTargetFromSource, getOclAnyType, getType, invoke, invoke, invokeSuper, isHelper, oclIsKindOf, oclIsTypeOf, oclIsUndefined, oclType, operatorEQ, operatorNE, output, refGetValue, refImmediateComposite, refImmediateComposite, refInvokeOperation, refSetValue, refUnsetValue, set, setType, toString, unset`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`getNativeImpl`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### myType

    public static ASMOclType myType

### Constructor Detail

#### ASMModel

    public ASMModel​(java.lang.String name,
                    ASMModel metamodel,
                    boolean isTarget,
                    ModelLoader ml)

### Method Detail

#### getModelLoader

    public ModelLoader getModelLoader()

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### getElementsByType

    public java.util.Set getElementsByType​(java.lang.String typeName)

#### getElementsByType

    public abstract java.util.Set getElementsByType​(ASMModelElement type)

#### findModelElement

    public abstract ASMModelElement findModelElement​(java.lang.String name)

Finds a Classifier in a Metamodel.

#### newModelElement

    public ASMModelElement newModelElement​(java.lang.String typeName)

#### newModelElement

    public ASMModelElement newModelElement​(StackFrame frame,
                                           java.lang.String typeName)

#### newModelElement

    public abstract ASMModelElement newModelElement​(ASMModelElement type)

#### getName

    public java.lang.String getName()

#### getMetamodel

    public ASMModel getMetamodel()

#### isTarget

    public boolean isTarget()

#### setIsTarget

    public void setIsTarget​(boolean isTarget)

#### isCheckSameModel

    public boolean isCheckSameModel()

Returns whether this model allows references to other models (inter-model references).

Returns:
  Whether this model allows references to other models (inter-model references).

#### setCheckSameModel

    public void setCheckSameModel​(boolean checkSameModel)

Sets whether this model allows references to other models (inter-model references).

Parameters:
  `checkSameModel` - whether this model allows references to other models (inter-model references).